﻿using System.IO;
using System.Windows.Forms;
using Styx;
using Styx.Helpers;

namespace ShutUp
{
    public class ChatKeywords : Settings
    {
        public static ChatKeywords Instance = new ChatKeywords();

        public ChatKeywords()
            : base(Application.StartupPath + "\\Plugins\\ShutUp\\SpecificAnswer\\ChatKeywords.xml")
        {
            Load();
        }

        ~ChatKeywords()
        {
            Save();
        }

        [Setting(Explanation = "keyword List"), DefaultValue(null)]
        public string[] chatKeywords { get; set; }
    }

    public class SpecificAnswer : Settings
    {
        public SpecificAnswer(string Keyword)
            : base(Application.StartupPath + "\\Plugins\\ShutUp\\SpecificAnswer\\Answer\\" + Keyword + ".xml")
        {
            Load();
        }

        ~SpecificAnswer()
        {
            Save();
        }

        [Setting(Explanation = "answer List"), DefaultValue(null)]
        public string[] specificAnswer { get; set; }
    }
}
